Package com.smartgwt.client.widgets.layout

# Class NavPanel

java.lang.Object
com.google.gwt.user.client.ui.UIObject
com.google.gwt.user.client.ui.Widget
com.smartgwt.client.widgets.BaseWidget
com.smartgwt.client.widgets.Canvas
com.smartgwt.client.widgets.layout.Layout
com.smartgwt.client.widgets.layout.SplitPane
com.smartgwt.client.widgets.layout.NavPanel

All Implemented Interfaces:
  `HasAttachHandlers`, `HasHandlers`, `EventListener`, `HasVisibility`, `IsWidget`, `LogicalStructure`, `HasClearHandlers`, `HasClickHandlers`, `HasDoubleClickHandlers`, `HasDragMoveHandlers`, `HasDragRepositionMoveHandlers`, `HasDragRepositionStartHandlers`, `HasDragRepositionStopHandlers`, `HasDragResizeMoveHandlers`, `HasDragResizeStartHandlers`, `HasDragResizeStopHandlers`, `HasDragStartHandlers`, `HasDragStopHandlers`, `HasDropHandlers`, `HasDropMoveHandlers`, `HasDropOutHandlers`, `HasDropOverHandlers`, `HasFocusChangedHandlers`, `HasHoverHandlers`, `HasHoverHiddenHandlers`, `HasKeyDownHandlers`, `HasKeyPressHandlers`, `HasMouseDownHandlers`, `HasMouseMoveHandlers`, `HasMouseOutHandlers`, `HasMouseOverHandlers`, `HasMouseStillDownHandlers`, `HasMouseUpHandlers`, `HasMouseWheelHandlers`, `HasMovedHandlers`, `HasParentMovedHandlers`, `HasResizedHandlers`, `HasRightMouseDownHandlers`, `HasRuleContextChangedHandlers`, `HasScrolledHandlers`, `HasShowContextMenuHandlers`, `HasVisibilityChangedHandlers`, `HasDownClickHandlers`, `HasMembersChangedHandlers`, `HasNavigationClickHandlers`, `HasPaneChangedHandlers`, `HasUpClickHandlers`

public class NavPanel extends SplitPane
Provides a list or tree of `navigation items`, each of which specifies a component to be displayed in a mutually exclusive fashion in the `navDeck`.

A NavPanel can either have a flat list of `NavItems` or a hierarchy via `NavItem.items` - use `isTree` to explicitly control this.

Because NavPanel extends `SplitPane`, it automatically shifts between side-by-side vs single panel display on handset-sized devices. Specifically, the `navGrid` is set as the `SplitPane.navigationPane` and the `navDeck` is set as the `SplitPane.detailPane`.

Note that `NavPanel` is a fairly simple component to replicate by composing other Smart GWT widgets. If you need a component that looks roughly like a `NavPanel` but will require lots of visual and behavioral customization, consider using the underlying components directly instead of deeply customizing the `NavPanel` class. A `NavPanel` is essentially just a `TreeGrid` and `Deck` in a `SplitPane`, with a `recordClick` handler to call `Deck.setCurrentPane()` with a component ID stored as an attribute of each Record.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

  `UIObject.DebugIdImpl, UIObject.DebugIdImplEnabled`

- ## Field Summary

  ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

  `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

  ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

  `DEBUG_ID_PREFIX`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NavPanel()`
  `NavPanel(JavaScriptObject jsObj)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `changeAutoChildDefaults(String autoChildName, Canvas defaults)`
  Changes the defaults for Canvas AutoChildren named `autoChildName`.
  `static void`
  `changeAutoChildDefaults(String autoChildName, FormItem defaults)`
  Changes the defaults for FormItem AutoChildren named `autoChildName`.
  `protected JavaScriptObject`
  `create()`
  `Boolean`
  `getAutoOpenItems()`
  When `isTree` is true, should all nodes be opened automatically? Set to `false` to prevent nodes being opened by default.
  `NavItem`
  `getCurrentItem()`
  The current `NavItem` whose `pane` is showing in the `navDeck`.
  `String`
  `getCurrentItemId()`
  The ID of the current `NavItem` whose `pane` is showing in the `navDeck`.
  `String`
  `getDeckStyle()`
  CSS style for the `navDeck`.
  `Boolean`
  `getDefaultToFirstItem()`
  Select the first `NavItem` on initialization if neither `currentItemId` nor `currentItem` are provided.
  `String`
  `getHeaderStyle()`
  CSS style used when `NavItem.isHeader` is set on an item.
  `Boolean`
  `getIsTree()`
  Whether the `NavItem`s form a `Tree` or are just a flat list.
  `LogicalStructureObject`
  `getLogicalStructure()`
  Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `Deck`
  `getNavDeck()`
  The `Deck` area where components specified via `NavItem.pane` are displayed.
  `TreeGrid`
  `getNavGrid()`
  The `TreeGrid` used to display `NavItem`s.
  `String`
  `getNavItemBaseStyle()`
  Pass through to set the `basestyle` on the `navGrid` autoChild.
  `NavItem[]`
  `getNavItems()`
  Top-level navigation items to display.
  `VLayout`
  `getNavLayout()`
  The layout serving as the `navigationPane` of this panel.
  `static NavPanel`
  `getOrCreateRef(JavaScriptObject jsObj)`
  `NavPanel`
  `setAutoOpenItems(Boolean autoOpenItems)`
  When `isTree` is true, should all nodes be opened automatically? Set to `false` to prevent nodes being opened by default.
  `NavPanel`
  `setCurrentItem(NavItem currentItem)`
  The current `NavItem` whose `pane` is showing in the `navDeck`.
  `NavPanel`
  `setCurrentItemId(String currentItemId)`
  The ID of the current `NavItem` whose `pane` is showing in the `navDeck`.
  `NavPanel`
  `setDeckStyle(String deckStyle)`
  CSS style for the `navDeck`.
  `static void`
  `setDefaultProperties(NavPanel navPanelProperties)`
  Class level method to set the default properties of this class.
  `NavPanel`
  `setDefaultToFirstItem(Boolean defaultToFirstItem)`
  Select the first `NavItem` on initialization if neither `currentItemId` nor `currentItem` are provided.
  `NavPanel`
  `setHeaderStyle(String headerStyle)`
  CSS style used when `NavItem.isHeader` is set on an item.
  `NavPanel`
  `setIsTree(Boolean isTree)`
  Whether the `NavItem`s form a `Tree` or are just a flat list.
  `LogicalStructureObject`
  `setLogicalStructure(NavPanelLogicalStructure s)`
  Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
  `NavPanel`
  `setNavAfterMembers(Canvas... navAfterMembers)`
  Members to add after the `navGrid` in the `navLayout` when the panel is first drawn.
  `NavPanel`
  `setNavBeforeMembers(Canvas... navBeforeMembers)`
  Members to add before the `navGrid` in the `navLayout` when the panel is first drawn.
  `NavPanel`
  `setNavItemBaseStyle(String navItemBaseStyle)`
  Pass through to set the `basestyle` on the `navGrid` autoChild.
  `NavPanel`
  `setNavItems(NavItem... navItems)`
  Top-level navigation items to display.

  ### Methods inherited from class com.smartgwt.client.widgets.layout.SplitPane

  `addDownClickHandler, addNavigationClickHandler, addPaneChangedHandler, addUpClickHandler, getAddHistoryEntries, getAnimateNavigationBarStateChanges, getAutoNavigate, getBackButton, getCurrentPane, getDetailNavigationControl, getDetailPane, getDetailPaneTitleTemplate, getDetailTitle, getDetailToolButtons, getDetailToolStrip, getDeviceMode, getEditProxyConstructor, getLeftButton, getListPane, getListPaneTitleTemplate, getListTitle, getListToolStrip, getNavigationBar, getNavigationPane, getNavigationPaneWidth, getNavigationPaneWidthAsString, getNavigationTitle, getNotifyAfterNavigationClick, getPageOrientation, getReverseOrder, getShowDetailToolStrip, getShowLeftButton, getShowListToolStrip, getShowMiniNav, getShowNavigationBar, getShowResizeBars, getShowRightButton, getVertical, navigateDetailPane, navigateDetailPane, navigateListPane, navigateListPane, navigatePane, navigatePane, navigatePane, navigatePane, setAddHistoryEntries, setAnimateNavigationBarStateChanges, setAutoNavigate, setCurrentPane, setDefaultProperties, setDetailNavigationControl, setDetailPane, setDetailPaneTitleTemplate, setDetailTitle, setDetailToolButtons, setDeviceMode, setEditProxyConstructor, setLeftButtonTitle, setListPane, setListPaneTitleTemplate, setListTitle, setLogicalStructure, setNavigationPane, setNavigationPaneWidth, setNavigationPaneWidth, setNavigationTitle, setNotifyAfterNavigationClick, setPageOrientation, setReverseOrder, setRightButtonTitle, setShowDetailToolStrip, setShowLeftButton, setShowListToolStrip, setShowMiniNav, setShowNavigationBar, setShowResizeBars, setShowRightButton, setVertical, showDetailPane, showDetailPane, showDetailPane, showDetailPane, showListPane, showListPane, showListPane, showListPane, showNavigationPane, showNavigationPane`

  ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

  `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersAsStringArray, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit, onInit_Layout, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, replaceMember, revealChild, revealChild, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVisibleMember, setVPolicy, showMember, showMember`

  ### Methods inherited from class com.smartgwt.client.widgets.Canvas

  `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsEventTarget, containsFocus, containsPoint, containsPoint, contentsComponentConnected, dataContextChanged, dataContextCriteriaChanged, deparent, depeer, disable, doValueDictation, doVoiceCommand, enable, encloses, endBatchCreation, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAllCanvases, getAllCanvases, getAllCanvases, getAlwaysManageFocusNavigation, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeLayoutMode, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaHandleID, getAriaRole, getAriaStateDefaults, getAutoMaskComponents, getAutoParent, getAutoPopulateData, getAutoRevertStyles, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBorderRadius, getBorderRadiusAsString, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanDropContent, getCanDropFiles, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenAsStringArray, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContentsComponentDefaults, getContextMenu, getControlHeight, getCorrectZoomOverflow, getCursor, getDataContext, getDataContextCriteria, getDataContextCriteria, getDataPath, getDefaultHeight, getDefaultWidth, getDeferActionConversion, getDefiningProperty, getDefiningPropertyName, getDefiningPropertyNameOptions, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragTargetAsString, getDragType, getDropTarget, getDropTargetAsString, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getEvents, getExtraSpace, getFacetId, getFloatingScrollbars, getFormItemAutoChild, getForwardSVGeventsToObject, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupPadding, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverFocusKey, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverPersist, getHoverScreen, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlElementAsString, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeaveGroupLabelSpace, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateByIDOnly, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getLocatorName, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMatchElementHeight, getMatchElementWidth, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getName, getNativeAutoHideScrollbars, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentCanvasAsString, getParentElement, getParentElementAsString, getPeers, getPendingMarkerStyle, getPendingMarkerVisible, getPercentBox, getPercentSource, getPersistentMatchElement, getPointerSettings, getPointerTarget, getPointerTargetAsString, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrintStyleName, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getReceiveScrollbarEvents, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShareCriteria, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowFocusOutline, getShowHover, getShowHoverComponents, getShowPointer, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSingleDiv, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapGridLineProperties, getSnapGridStyle, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getStyleName, getSuppressRedraw, getTabIndex, getTestDataContext, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getTopLevelComponents, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseBackMask, getUseCSSShadow, getUseDataContextCriteria, getUseDragMask, getUseGeneratedStyles, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getWorkflows, getZIndex, getZIndex, handleDataContextCriteria, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, initComplete, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, print, print, print, print, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, registerAIService, registerFontScaledPaddingStyles, removeChild, removeChild, removePeer, removePeer, removeRuleContext, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeControlsTo, resizeFonts, resizeFonts, resizeFonts, resizeFontsTo, resizeIcons, resizePadding, resizePadding, resizeTo, resizeTo, resolveContentsComponent, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysManageFocusNavigation, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeLayoutMode, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoPopulateData, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoRevertStyles, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBorderRadius, setBorderRadius, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanDropContent, setCanDropFiles, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContentsComponentDefaults, setContextMenu, setCorrectZoomOverflow, setCursor, setDataContext, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataContextCriteria, setDataPath, setDefaultHeight, setDefaultNativeAutoHideScrollbars, setDefaultPageSpace, setDefaultProperties, setDefaultShowCustomScrollbars, setDefaultWidth, setDeferActionConversion, setDefiningProperty, setDefiningPropertyNameOptions, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragTarget, setDragType, setDropTarget, setDropTarget, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setFloatingScrollbars, setForwardSVGeventsToObject, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupPadding, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverFocusKey, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverPersist, setHoverScreen, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeaveGroupLabelSpace, setLeavePageSpace, setLeft, setLeft, setLocateByIDOnly, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLocatorName, setLocatorParent, setLocatorParent, setLogicalStructure, setMargin, setMatchElement, setMatchElementHeight, setMatchElementWidth, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setName, setNativeAutoHideScrollbars, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentCanvas, setParentElement, setParentElement, setPeers, setPendingMarkerStyle, setPendingMarkerVisible, setPercentBox, setPercentSource, setPersistentMatchElement, setPointerSettings, setPointerTarget, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrintStyleName, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setReceiveScrollbarEvents, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShareCriteria, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowFocusOutline, setShowHover, setShowHoverComponents, setShowPointer, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSingleDiv, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapGridLineProperties, setSnapGridStyle, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setStyleName, setSuppressRedraw, setTabIndex, setTestDataContext, setTitle, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseBackMask, setUseCSSShadow, setUseDataContextCriteria, setUseDragMask, setUseGeneratedStyles, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setWorkflows, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPendingMarker, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, startBatchCreation, startDebuggingOverflow, stopDebuggingOverflow, subtractRects, supportsValueDictation, supportsVoiceCommands, unregisterAIService, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

  ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

  `addDrawHandler, addDynamicProperty, addDynamicProperty, addDynamicProperty, addDynamicProperty, applyFactoryProperties, clearDynamicProperty, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getAutoDraw, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hasDynamicProperty, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoDraw, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

  ### Methods inherited from class com.google.gwt.user.client.ui.Widget

  `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

  ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

  `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

  `fireEvent`

- ## Constructor Details

  - ### NavPanel

    public NavPanel()

  - ### NavPanel

    public NavPanel(JavaScriptObject jsObj)

- ## Method Details

  - ### getOrCreateRef

    public static NavPanel getOrCreateRef(JavaScriptObject jsObj)

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, Canvas defaults)
    Changes the defaults for Canvas AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### changeAutoChildDefaults

    public static void changeAutoChildDefaults(String autoChildName, FormItem defaults)
    Changes the defaults for FormItem AutoChildren named `autoChildName`.
    Parameters:
      `autoChildName` - name of an AutoChild to customize the defaults for.
      `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
    See Also:
      - `AutoChildUsage`

  - ### create

    protected JavaScriptObject create()
    Overrides:
      `create` in class `SplitPane`

  - ### setAutoOpenItems

    public NavPanel setAutoOpenItems(Boolean autoOpenItems) throws IllegalStateException
    When `isTree` is true, should all nodes be opened automatically? Set to `false` to prevent nodes being opened by default.
    Parameters:
      `autoOpenItems` - New autoOpenItems value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getAutoOpenItems

    public Boolean getAutoOpenItems()
    When `isTree` is true, should all nodes be opened automatically? Set to `false` to prevent nodes being opened by default.
    Returns:
      Current autoOpenItems value. Default value is null

  - ### setCurrentItem

    public NavPanel setCurrentItem(NavItem currentItem)
    The current `NavItem` whose `pane` is showing in the `navDeck`. This must be an item of this `NavPanel` if set.
    If this method is called after the component has been drawn/initialized: Setter for `currentItem`. Note that `currentItemId` is also updated by this setter.
    Parameters:
      `currentItem` - the new `currentItem`. May be `null` to hide the current item. If `newCurrentItem` is a separator or header item, then setCurrentItem() has no effect. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls

  - ### getCurrentItem

    public NavItem getCurrentItem()
    The current `NavItem` whose `pane` is showing in the `navDeck`. This must be an item of this `NavPanel` if set.
    Returns:
      Current currentItem value. Default value is null

  - ### setCurrentItemId

    public NavPanel setCurrentItemId(String currentItemId)
    The ID of the current `NavItem` whose `pane` is showing in the `navDeck`. The `NavItem` must be an item of this `NavPanel` if set.

    The ID of a `NavItem` is the item's `NavItem.id` if set; otherwise, it is the ID of the item's `NavItem.pane`, though `currentItemId` may be initialized to either identifier.
    If this method is called after the component has been drawn/initialized: Setter for `currentItemId`. Note that `currentItem` is also updated by this setter and `this.currentItemId` may be normalized to a different identifier.

    Parameters:
      `currentItemId` - the ID of the new current item, which may be either the item's `NavItem.id` or the ID of the item's `NavItem.pane`. May be `null` or an empty string to hide the current item. If the item with ID `newCurrentItemId` is a separator or header item, then setCurrentItemId() has no effect. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    See Also:
      - `Identifier`

  - ### getCurrentItemId

    public String getCurrentItemId()
    The ID of the current `NavItem` whose `pane` is showing in the `navDeck`. The `NavItem` must be an item of this `NavPanel` if set.

    The ID of a `NavItem` is the item's `NavItem.id` if set; otherwise, it is the ID of the item's `NavItem.pane`, though `currentItemId` may be initialized to either identifier.

    Returns:
      Current currentItemId value. Default value is null
    See Also:
      - `Identifier`

  - ### setDeckStyle

    public NavPanel setDeckStyle(String deckStyle) throws IllegalStateException
    CSS style for the `navDeck`.
    Parameters:
      `deckStyle` - New deckStyle value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`

  - ### getDeckStyle

    public String getDeckStyle()
    CSS style for the `navDeck`.
    Returns:
      Current deckStyle value. Default value is null
    See Also:
      - `CSSStyleName`

  - ### setDefaultToFirstItem

    public NavPanel setDefaultToFirstItem(Boolean defaultToFirstItem)
    Select the first `NavItem` on initialization if neither `currentItemId` nor `currentItem` are provided.
    Parameters:
      `defaultToFirstItem` - New defaultToFirstItem value. Default value is false
    Returns:
      `NavPanel` instance, for chaining setter calls

  - ### getDefaultToFirstItem

    public Boolean getDefaultToFirstItem()
    Select the first `NavItem` on initialization if neither `currentItemId` nor `currentItem` are provided.
    Returns:
      Current defaultToFirstItem value. Default value is false

  - ### setHeaderStyle

    public NavPanel setHeaderStyle(String headerStyle) throws IllegalStateException
    CSS style used when `NavItem.isHeader` is set on an item. May be overridden for a specific header item by `NavItem.customStyle`.
    Parameters:
      `headerStyle` - New headerStyle value. Default value is "navItemHeader"
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `CSSStyleName`

  - ### getHeaderStyle

    public String getHeaderStyle()
    CSS style used when `NavItem.isHeader` is set on an item. May be overridden for a specific header item by `NavItem.customStyle`.
    Returns:
      Current headerStyle value. Default value is "navItemHeader"
    See Also:
      - `CSSStyleName`

  - ### setIsTree

    public NavPanel setIsTree(Boolean isTree) throws IllegalStateException
    Whether the `NavItem`s form a `Tree` or are just a flat list. If `isTree` is false, `TreeGrid.showOpener` will be set false on the `navGrid` so that space isn't wasted.

    The setting for `isTree` is defaulted immediately before initial draw, based on whether any `NavItem` has a list of subitems specified via `NavItem.items`. If no `NavItem`s are provided before draw, `isTree` defaults to `true`. Auto-detection is never attempted again even if all `NavItems` are replaced.

    Set `isTree` explicitly if auto-detection doesn't yield the correct result for your application.

    Parameters:
      `isTree` - New isTree value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getIsTree

    public Boolean getIsTree()
    Whether the `NavItem`s form a `Tree` or are just a flat list. If `isTree` is false, `TreeGrid.showOpener` will be set false on the `navGrid` so that space isn't wasted.

    The setting for `isTree` is defaulted immediately before initial draw, based on whether any `NavItem` has a list of subitems specified via `NavItem.items`. If no `NavItem`s are provided before draw, `isTree` defaults to `true`. Auto-detection is never attempted again even if all `NavItems` are replaced.

    Set `isTree` explicitly if auto-detection doesn't yield the correct result for your application.

    Returns:
      Current isTree value. Default value is null

  - ### setNavAfterMembers

    public NavPanel setNavAfterMembers(Canvas... navAfterMembers) throws IllegalStateException
    Members to add after the `navGrid` in the `navLayout` when the panel is first drawn.
    Parameters:
      `navAfterMembers` - New navAfterMembers value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### setNavBeforeMembers

    public NavPanel setNavBeforeMembers(Canvas... navBeforeMembers) throws IllegalStateException
    Members to add before the `navGrid` in the `navLayout` when the panel is first drawn.
    Parameters:
      `navBeforeMembers` - New navBeforeMembers value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created

  - ### getNavDeck

    public Deck getNavDeck() throws IllegalStateException
    The `Deck` area where components specified via `NavItem.pane` are displayed.

    This component is an AutoChild named "navDeck". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current navDeck value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### getNavGrid

    public TreeGrid getNavGrid() throws IllegalStateException
    The `TreeGrid` used to display `NavItem`s.

    This component is an AutoChild named "navGrid". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current navGrid value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setNavItemBaseStyle

    public NavPanel setNavItemBaseStyle(String navItemBaseStyle) throws IllegalStateException
    Pass through to set the `basestyle` on the `navGrid` autoChild.
    Parameters:
      `navItemBaseStyle` - New navItemBaseStyle value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls
    Throws:
      `IllegalStateException` - this property cannot be changed after the component has been created
    See Also:
      - `ListGrid.getBaseStyle()`
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### getNavItemBaseStyle

    public String getNavItemBaseStyle()
    Pass through to set the `basestyle` on the `navGrid` autoChild.
    Returns:
      Current navItemBaseStyle value. Default value is null
    See Also:
      - `ListGrid.getBaseStyle()`
      - `CSSStyleName`
      - `Appearance overview and related methods`

  - ### setNavItems

    public NavPanel setNavItems(NavItem... navItems)
    Top-level navigation items to display. You can optionally specify a tree of items using `NavItem.items`.

    A separator between navigation items can be created by setting `NavItem.isSeparator`, and a header can be created via `NavItem.isHeader`.

    Each non-separator and non-header `NavItem` specifies a component to be displayed in the `navDeck` via `NavItem.pane`.

    `NavItem`s can also be individually styled via `ListGridRecord._baseStyle` or `NavItem.customStyle`.

    Parameters:
      `navItems` - New navItems value. Default value is null
    Returns:
      `NavPanel` instance, for chaining setter calls

  - ### getNavItems

    public NavItem[] getNavItems()
    Top-level navigation items to display. You can optionally specify a tree of items using `NavItem.items`.

    A separator between navigation items can be created by setting `NavItem.isSeparator`, and a header can be created via `NavItem.isHeader`.

    Each non-separator and non-header `NavItem` specifies a component to be displayed in the `navDeck` via `NavItem.pane`.

    `NavItem`s can also be individually styled via `ListGridRecord._baseStyle` or `NavItem.customStyle`.

    Returns:
      Current navItems value. Default value is null

  - ### getNavLayout

    public VLayout getNavLayout() throws IllegalStateException
    The layout serving as the `navigationPane` of this panel. By default it contains only the `navGrid`, but other members can be added before or after, respectively, via `navBeforeMembers` and `navAfterMembers`.

    This component is an AutoChild named "navLayout". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

    Returns:
      Current navLayout value. Default value is null
    Throws:
      `IllegalStateException` - if this widget has not yet been rendered.

  - ### setDefaultProperties

    public static void setDefaultProperties(NavPanel navPanelProperties)
    Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

    Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

    Parameters:
      `navPanelProperties` - properties that should be used as new defaults when instances of this class are created
    See Also:
      - `SGWTProperties`

  - ### setLogicalStructure

    public LogicalStructureObject setLogicalStructure(NavPanelLogicalStructure s)
    Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

  - ### getLogicalStructure

    public LogicalStructureObject getLogicalStructure()
    Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    Specified by:
      `getLogicalStructure` in interface `LogicalStructure`
    Overrides:
      `getLogicalStructure` in class `SplitPane`